#ifndef STARSInterface_h
#define STARSInterface_h

#include <interfaces/abstract/STARSSegment.h>
#include <interfaces/abstract/STARSFunction.h>

class STARS_Interface_t
{
	public:

/*
 * Segment methods
 */

		/* return segment for virtual addr */
		virtual STARS_Segment_t *getseg(const STARS_ea_t &addr) =0; 

		/* Return segment at index "index" */
		virtual STARS_Segment_t *getnseg(const int &index) =0; 

		/* return number of segments */
		virtual size_t get_segm_qty() =0;

		virtual STARS_Segment_t *get_next_seg(const STARS_ea_t &addr) =0;

/*
 * Function methods
 */
		/* find out how many functions there is */
		virtual size_t get_func_qty()=0;

		/* get the index-th function */
		virtual STARS_Function_t *getn_func(int index) =0;

		/* get the function at the given address */
		virtual STARS_Function_t *get_func(STARS_ea_t index) =0;

};

extern STARS_Interface_t* global_stars_interface;

#endif



